//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbvtkMaskPoint.h"
#include "bbvtkPackage.h"
namespace bbvtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(vtk,MaskPoint)
BBTK_BLACK_BOX_IMPLEMENTATION(MaskPoint,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MaskPoint::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')


	if (bbGetInputActive()==true)
	{
	//EED 2017-01-01 Migration VTK7
	#if (VTK_MAJOR_VERSION <= 5) 
		  	maskpoints->SetInput( bbGetInputIn() );  
	#endif
	#if (VTK_MAJOR_VERSION >= 6) 
		  	maskpoints->SetInputData( bbGetInputIn() );  
	#endif

		maskpoints->SetOnRatio( bbGetInputRatio() );

		if (bbGetInputRandomType()==-1)
		{
			maskpoints->RandomModeOff();	
		} else if(bbGetInputRandomType()==0) {
			maskpoints->RandomModeOn();	
			maskpoints->SetRandomModeType(0);
		}

	//	maskpoints->SetMaximumNumberOfPoints(5000);	
		maskpoints->Update();
	   	bbSetOutputOut( maskpoints->GetOutput() );
	} // if Active
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MaskPoint::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputActive( true );
   bbSetInputIn(NULL);
   bbSetOutputOut(NULL);
   bbSetInputRandomType(-1);
   bbSetInputRatio(30);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MaskPoint::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

   maskpoints = vtkMaskPoints::New();
  

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MaskPoint::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
     maskpoints->Delete();
}

}  // EO namespace bbvtk


